#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr 13 14:42:20 2020

@author: fredodurand
"""


#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Apr  9 14:20:37 2020

@author: fredodurand
"""

import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons
import random

# you probably need to change the properties of your spyder to get the real-time update of graphs: 
#Ipython console ->  backend -> automatic


# 
#plt.xkcd(scale=1, length=100, randomness=2)


def simulation_sir(beta, gamma, initial_I=100, initial_R_fraction = 0.0, population = 327e6, duration = 365):

    I = [initial_I]
    R = [initial_R_fraction*population]   
    S = [population - R[-1]]
   
    for t in range(duration):
        new_infected = beta*I[-1]*S[-1] / population
        new_recovered = gamma * I[-1]
        I.append(I[-1] + new_infected - new_recovered)
        S.append(S[-1] - new_infected)
        R.append(R[-1] + new_recovered)
         
    return S, I, R


R0 = 2.6
gamma = 1/5
beta = R0*gamma

L_S, L_I, L_R = simulation_sir(beta, gamma)


fig, ax = plt.subplots()
plt.subplots_adjust(left=0.25, bottom=0.25)
#t = np.arange(0.0, 1.0, 0.001)

#s = a0 * np.sin(2 * np.pi * f0 * t)
l, = plt.plot( L_I)
l2, = plt.plot( L_R)
l3, = plt.plot( L_S)

axR0 = plt.axes([0.25, 0.15, 0.65, 0.03])
axDuration = plt.axes([0.25, 0.1, 0.65, 0.03])

sR0 = Slider(axR0, 'R0', 0.5, 5.0, valinit=2.5)
sDuration = Slider(axDuration, 'Duration', 3.0, 15.0, valinit=5.0)



def update(val):
    R0 = sR0.val
    duration = sDuration.val

    gamma = 1/duration
    beta = R0*gamma

    L_S, L_I, L_R = simulation_sir(beta, gamma)    
    l.set_ydata(L_I)
    l2.set_ydata(L_R)
    l3.set_ydata(L_S)
    fig.canvas.draw_idle()

sR0.on_changed(update)
sDuration.on_changed(update)

plt.show()



#################################

#      VACCINATION

#################################





# def simulation_sir(beta, gamma, initial_I=100, initial_R_fraction = 0.0, population = 327e6, duration = 90):

#     I = [initial_I]
#     R = [initial_R_fraction*population]   
#     S = [population - R[-1]]
   
#     for t in range(duration):
#         new_infected = beta*I[-1]*S[-1] / population
#         new_recovered = gamma * I[-1]
#         I.append(max(0, I[-1] + new_infected - new_recovered))
#         S.append(max(0, S[-1] - new_infected))
#         R.append(max(0, R[-1] + new_recovered))
         
#         total = I[-1]+S[-1]+I[-1]
#         # S[-1]=S[-1]/total*population
#         # I[-1]=I[-1]/total*population
#         # R[-1]=R[-1]/total*population
        
#     return S, I, R


# R0 = 2.6
# gamma = 1/5
# beta = R0*gamma

# L_S, L_I, L_R = simulation_sir(beta, gamma)


# fig, ax = plt.subplots()
# plt.subplots_adjust(left=0.25, bottom=0.25)
# #t = np.arange(0.0, 1.0, 0.001)

# #s = a0 * np.sin(2 * np.pi * f0 * t)
# l, = plt.semilogy( L_I)
# plt.ylim(1, 1e7)

# #l2, = plt.plot( L_R)
# #l3, = plt.plot( L_S)

# axR0 = plt.axes([0.25, 0.15, 0.65, 0.03])
# axVaccinationRate = plt.axes([0.25, 0.1, 0.65, 0.03])

# sR0 = Slider(axR0, 'R0', 0.5, 5.0, valinit=2.5)
# sVaccinationRate = Slider(axVaccinationRate, 'Vaccination rate', 0.0, 1.0, valinit=.5)



# def update(val):
#     R0 = sR0.val
#     duration = 1/5

#     gamma = 1/duration
#     beta = R0*gamma
#     vaccination_rate = sVaccinationRate.val
    
#     L_S, L_I, L_R = simulation_sir(beta, gamma, initial_R_fraction = vaccination_rate)    
#     l.set_ydata(L_I)
#     #l2.set_ydata(L_R)
#     #l3.set_ydata(L_S)
#     fig.canvas.draw_idle()

# sR0.on_changed(update)
# sVaccinationRate.on_changed(update)
# update(None)
# plt.show()


#################################

#      INTERVENTION

#################################



# def simulation_sir_trigerred_intervention(beta, gamma, 
#                                           number_cases_intervention=100000, 
#                                           fraction=0.5, 
#                                           population = 327e6, initial_I=1000, 
#                                           duration = 365):
    
#     I = [initial_I]
#     S = [population - initial_I]
#     R = [0]   
#     intervention = False
   
#     for t in range(duration):
#         if not intervention and I[-1]>number_cases_intervention:
#             intervention = True
#         if intervention:
#             effective_beta = beta*fraction
#         else: 
#             effective_beta = beta
            
#         new_infected = effective_beta*I[-1]*S[-1] / population
#         new_recovered = gamma * I[-1]
#         I.append( I[-1] + new_infected - new_recovered )
#         S.append( S[-1] - new_infected)
#         R.append( R[-1] + new_recovered)
         
#     return S, I, R


# R0 = 2.6
# gamma = 1/5
# beta = R0*gamma


# L_S, L_I, L_R = simulation_sir_trigerred_intervention(beta, gamma, fraction=0.7 )


# fig, ax = plt.subplots()
# plt.subplots_adjust(left=0.25, bottom=0.25)
# #t = np.arange(0.0, 1.0, 0.001)

# #s = a0 * np.sin(2 * np.pi * f0 * t)
# l, = plt.plot( L_I)
# #plt.ylim(1, 1e7)

# #l2, = plt.plot( L_R)
# #l3, = plt.plot( L_S)

# axFraction = plt.axes([0.25, 0.15, 0.65, 0.03])
# axTrigger = plt.axes([0.25, 0.1, 0.65, 0.03])

# sFraction = Slider(axFraction, 'Intervention', 0.0, 1.0, valinit=0.0)
# sTrigger = Slider(axTrigger, 'Log_10 Trigger', 3, 7, valinit=5)



# def update(val):
#     fraction = 1.0-sFraction.val
#     trigger = 10**sTrigger.val
    
#     L_S, L_I, L_R = simulation_sir_trigerred_intervention(beta, gamma, \
#                                                           fraction = fraction, \
#                                                           number_cases_intervention = trigger)    
#     l.set_ydata(L_I)
#     #l2.set_ydata(L_R)
#     #l3.set_ydata(L_S)
#     fig.canvas.draw_idle()

# sFraction.on_changed(update)
# sTrigger.on_changed(update)
# update(None)
# plt.show()




#################################

#      INTERVENTION MC

#################################



# def simulation_sir_trigerred_intervention(beta, gamma, 
#                                           number_cases_intervention=100000, 
#                                           fraction=0.5, 
#                                           population = 327e6, initial_I=1000, 
#                                           duration = 365):
    
#     I = [initial_I]
#     S = [population - initial_I]
#     R = [0]   
#     intervention = False
   
#     for t in range(duration):
#         if not intervention and I[-1]>number_cases_intervention:
#             intervention = True
#         if intervention:
#             effective_beta = beta*fraction
#         else: 
#             effective_beta = beta
            
#         new_infected = effective_beta*I[-1]*S[-1] / population
#         new_recovered = gamma * I[-1]
#         I.append( I[-1] + new_infected - new_recovered )
#         S.append( S[-1] - new_infected)
#         R.append( R[-1] + new_recovered)
         
#     return S, I, R


# R0 = 2.6
# gamma = 1/5
# beta = R0*gamma

# min_R0 = 2
# max_R0 = 3
# min_duration = 5
# max_duration = 5

# num_curves=10
# gamma = []
# beta = []
# for i in range(num_curves):
#     R0 = min_R0 + random.random()*(max_R0-min_R0)
#     duration = min_duration + random.random()*(max_duration-min_duration)
#     g = 1/duration
#     b = R0*g
#     gamma.append(g)
#     beta.append(b)



# fig, ax = plt.subplots()
# plt.subplots_adjust(left=0.25, bottom=0.25)
# #t = np.arange(0.0, 1.0, 0.001)

# #s = a0 * np.sin(2 * np.pi * f0 * t)

# l =[]
    
# for i in range(num_curves):
#     L_S, L_I, L_R = simulation_sir_trigerred_intervention(beta[i], gamma[i], fraction=0.7 )
#     ll, = plt.plot(L_I)
#     l.append(ll)
    
# plt.ylim(1, 1e7)

# #l2, = plt.plot( L_R)
# #l3, = plt.plot( L_S)

# axFraction = plt.axes([0.25, 0.15, 0.65, 0.03])
# axTrigger = plt.axes([0.25, 0.1, 0.65, 0.03])

# sFraction = Slider(axFraction, 'Intervention', 0.0, 1.0, valinit=0.0)
# sTrigger = Slider(axTrigger, 'Log_10 Trigger', 3, 7, valinit=5)



# def update(val):
#     random.seed(1)
#     fraction = 1.0-sFraction.val
#     trigger = 10**sTrigger.val
    
#     for i in range(num_curves):
#         L_S, L_I, L_R = simulation_sir_trigerred_intervention(beta[i], gamma[i], \
#                                                               fraction = fraction, \
#                                                               number_cases_intervention = trigger)    
#         l[i].set_ydata(L_I)
         
# sFraction.on_changed(update)
# sTrigger.on_changed(update)
# update(None)
# plt.show()



#################################

#      INTERVENTION STOPS

#################################


# def simulation_sir_intervention (beta, gamma, 
#                                           time_begin_intervention =30, 
#                                           time_end_intervention =60, 
#                                           fraction=0.5, 
#                                           population = 327e6, initial_I=1000, 
#                                           duration = 365):
    
#     I = [initial_I]
#     S = [population - initial_I]
#     R = [0]   

#     for t in range(duration):
#         effective_beta = beta
#         if t>time_begin_intervention and t<time_end_intervention:
#             effective_beta = beta * fraction
            
#         new_infected = effective_beta*I[-1]*S[-1] / population
#         new_recovered = gamma * I[-1]
#         I.append( I[-1] + new_infected - new_recovered )
#         S.append( S[-1] - new_infected)
#         R.append( R[-1] + new_recovered)
         
#     return S, I, R



# R0 = 2.6
# gamma = 1/5
# beta = R0*gamma
# duration = 180


# L_S, L_I, L_R = simulation_sir_intervention(beta, gamma, fraction=1.0, duration = duration )


# fig, ax = plt.subplots()
# plt.subplots_adjust(left=0.25, bottom=0.25)
# #t = np.arange(0.0, 1.0, 0.001)

# #s = a0 * np.sin(2 * np.pi * f0 * t)
# l, = plt.plot( L_I)
# #plt.ylim(1, 1e7)

# #l2, = plt.plot( L_R)
# #l3, = plt.plot( L_S)

# ax1 = plt.axes([0.25, 0.15, 0.65, 0.03])
# ax2 = plt.axes([0.25, 0.1, 0.65, 0.03])
# ax3 = plt.axes([0.25, 0.05, 0.65, 0.03])

# sFraction = Slider(ax1, 'Intervention', 0.0, 1.0, valinit=0.01)
# sBegin = Slider(ax2, 'begins', 10, duration, valinit=30)
# sEnd = Slider(ax3, 'ends', 10, duration, valinit=duration-2)




# def update(val):
#     fraction = 1.0-sFraction.val
#     begin = sBegin.val
#     end = sEnd.val
    
#     L_S, L_I, L_R = simulation_sir_intervention(beta, gamma, \
#                                                 fraction=fraction, \
#                                                     time_begin_intervention = begin, \
#                                                     time_end_intervention = end, \
#                                                     duration = duration )    
#     l.set_ydata(L_I)
#     #l2.set_ydata(L_R)
#     #l3.set_ydata(L_S)
#     fig.canvas.draw_idle()

# sFraction.on_changed(update)
# sBegin.on_changed(update)
# sEnd.on_changed(update)
# update(None)
# plt.show()


